diff --git src/daemon/common/commonSwarming.ml src/daemon/common/commonSwarming.ml
index 1e018f7..a044c59 100644
--- src/daemon/common/commonSwarming.ml
+++ src/daemon/common/commonSwarming.ml
@@ -118,13 +118,13 @@ type t = {
     mutable t_nverified_chunks : int;
 
     mutable t_verifier : verification; (* information available to
-					  check data correctness *)
+                                          check data correctness *)
     mutable t_verified : (int -> int -> unit); (* function to call
-						  when a chunk is verified;
-						  receives the number
-						  of verified chunks,
-						  and the index of the
-						  chunk just verified *)
+                                                  when a chunk is verified;
+                                                  receives the number
+                                                  of verified chunks,
+                                                  and the index of the
+                                                  chunk just verified *)
 
 (* mapping from network chunks to swarmer blocks *)
     mutable t_blocks_of_chunk : int list array;
@@ -139,10 +139,13 @@ and swarmer = {
     s_disk_allocation_block_size : int64;
 
     mutable s_networks : t list; (** list of frontends, primary at head 
-				     t.t_s = s <=> t in s.s_networks *)
+                                     t.t_s = s <=> t in s.s_networks *)
     mutable s_strategy : swarming_strategy;
 
     mutable s_verified_bitmap : VerificationBitmap.t;
+    mutable s_priorities_bitmap : string;
+    mutable s_priorities_intervals : (int64 * int) list;
+                                       (* beginning, priority *)
     mutable s_disk_allocated : Bitv.t;
     mutable s_availability : int array;
     mutable s_nuploading : int array;
@@ -150,7 +153,7 @@ and swarmer = {
 
     mutable s_blocks : block_v array;
     mutable s_block_pos : int64 array; (** offset of the beginning of
-					   each block *)
+                                           each block *)
   }
 
 and block_v =
@@ -165,14 +168,14 @@ and block = {
     mutable block_begin : Int64.t;
     mutable block_end : Int64.t;
     mutable block_ranges : range; (** [range] of the double-linked
-				      list of ranges associated to the
-				      [block] 
-				      what about using a standard list
-				      instead ? 
-				      or a balanced tree ? *)
+                                      list of ranges associated to the
+                                      [block] 
+                                      what about using a standard list
+                                      instead ? 
+                                      or a balanced tree ? *)
     mutable block_remaining : int64; (* amount of bytes missing. *)
     mutable block_unselected_remaining : int64; (* same, less ranges
-						   selected for uploaders. *)
+                                                   selected for uploaders. *)
   }
 
 and range = {
@@ -182,7 +185,7 @@ and range = {
     mutable range_prev : range option;
     mutable range_next : range option;
     mutable range_nuploading : int; (* number of uploaders currently
-				       referencing that range *)
+                                       referencing that range *)
   }
 
 and uploader = {
@@ -194,23 +197,23 @@ and uploader = {
     mutable up_intervals : intervals;
     mutable up_complete_blocks : int array; (** block numbers *)
     mutable up_ncomplete : int; (** number of blocks not yet handled,
-				    at the beginning of
-				    up_complete_blocks *)
+                                    at the beginning of
+                                    up_complete_blocks *)
 
     mutable up_partial_blocks : (int * int64 * int64) array; (** block
-								 number,
-								 begin_pos,
-								 end_pos
-								 *)
+                                                                 number,
+                                                                 begin_pos,
+                                                                 end_pos
+                                                                 *)
     mutable up_npartial : int; (** number of blocks not yet handled,
-				   at the beginning of
-				   up_partial_blocks *)
+                                   at the beginning of
+                                   up_partial_blocks *)
 
     mutable up_blocks : uploader_block list;
 
     mutable up_ranges : (int64 * int64 * range) list; (* ranges referenced by
-							 that uploader, see
-							 range_nuploading *)
+                                                         that uploader, see
+                                                         range_nuploading *)
   }
 and uploader_block = {
   up_block : block;
@@ -422,8 +425,8 @@ let cut_ranges_after b r cut_pos =
     if r.range_begin >= cut_pos then begin
       (match r.range_prev with
       | None -> 
-	  let b1 = r.range_block in
-	  b1.block_ranges <- void_range b1 cut_pos
+          let b1 = r.range_block in
+          b1.block_ranges <- void_range b1 cut_pos
       | Some rp ->
           rp.range_next <- None;
           r.range_prev <- None);
@@ -438,8 +441,8 @@ let cut_ranges_after b r cut_pos =
       (* across cut position, must split a range *)
       (* "right" half *)
       let split_r = { r with
-	range_begin = cut_pos;
-	range_prev = None;
+        range_begin = cut_pos;
+        range_prev = None;
       } in
       (match split_r.range_next with
       | None -> ()
@@ -450,7 +453,7 @@ let cut_ranges_after b r cut_pos =
       r.range_next <- None;
 
       if r.range_nuploading <> 0 then
-	lprintf_nl "WARNING: Splitting a range currently being uploaded, don't know what to do with range_nuploading :/";
+        lprintf_nl "WARNING: Splitting a range currently being uploaded, don't know what to do with range_nuploading :/";
 
       split_r in
   let cut_ranges = iter r in
@@ -554,11 +557,11 @@ let iter_intervals s f intervals =
         if i < nchunks && block_begin < interval_end then
           let block_end = compute_block_end s i in
           let current_end =  min block_end interval_end in
-	  
+          
           if debug_all then
             lprintf_nl "Apply: %d %Ld-%Ld %Ld-%Ld"
               i block_begin block_end interval_begin current_end;
-	  
+          
           f i block_begin block_end interval_begin current_end;
           iter_blocks (i+1) block_end block_end
       in
@@ -579,6 +582,8 @@ let dummy_swarmer = {
     s_networks = [];
     s_strategy = AdvancedStrategy;
     s_verified_bitmap = VB.create 0 VB.State_missing;
+    s_priorities_bitmap = "";
+    s_priorities_intervals = [(zero, 1)];
     s_disk_allocated = Bitv.create 0 false;
     s_blocks = [||];
     s_block_pos = [||];
@@ -586,15 +591,98 @@ let dummy_swarmer = {
     s_nuploading = [||];
   }
 
+let insert_prio_interval intervals last_end (new_start,new_end,new_prio) =
+  assert (new_start < new_end);
+  assert (new_end <= last_end);
+  let rec insert_end prev_prio = function
+    | [] -> if new_end = last_end then [] else if new_prio <> prev_prio then [new_end, prev_prio] else []
+    | (pos,prio as this) :: tail ->
+      match Int64.compare pos new_end with
+      | -1 -> insert_end prio tail (* eat it *)
+      | 1 ->
+        if new_prio <> prev_prio then
+          (new_end, prev_prio) :: this :: tail
+        else
+          this :: tail
+      | 0 ->
+        assert (prio <> prev_prio);
+        if new_prio <> prio then this :: tail else tail
+      | _ -> assert false
+  in
+  let rec insert prev_prio = function (* not tail rec ! *)
+    | [] -> 
+      if new_prio <> prev_prio then
+        (new_start, new_prio) :: insert_end prev_prio []
+      else
+        insert_end prev_prio []
+    | (pos, prio as this) :: tail ->
+      match Int64.compare pos new_start with
+      | -1 -> this :: insert prio tail (* leave current and continue searching *)
+      | 1 -> 
+        if new_prio <> prev_prio then
+          (new_start, new_prio) :: insert_end prev_prio (this::tail) (* mark new interval and search interval end *)
+        else
+          insert_end prev_prio (this::tail) (* start of new interval gets merged with previous interval *)
+      | 0 ->
+        assert (prio <> prev_prio); (* invariant *)
+        if new_prio <> prev_prio then
+          (new_start, new_prio) :: insert_end prio tail
+        else
+          insert_end prio tail
+      | _ -> assert false
+  in
+  insert (-1) intervals
+
+let rec validate_intervals limit = function
+  | (p1,prio1)::((p2,prio2)::_ as tail) when prio1 <> prio2 && p1 < p2 -> validate_intervals limit tail
+  | [p,_] when p < limit -> true
+  | _ -> false
+
+let priority_zero = Char.chr 0
+
+let swarmer_recompute_priorities_bitmap s =
+  String.fill s.s_priorities_bitmap 0
+    (String.length s.s_priorities_bitmap) priority_zero;
+  let mark interval_begin interval_end priority =
+    if interval_end > interval_begin && s.s_size >= interval_end && interval_begin >= 0L then
+      if priority = 0 then
+        () (* do not mark - zero blocks will not overwrite boundaries of non-zero blocks *)
+      else
+      begin
+        let i_begin = compute_block_num s interval_begin in
+        let i_end = compute_block_num s (Int64.pred interval_end) in
+        let priochar = Char.chr (max 0 (min priority 255)) in
+  (*       String.fill s.s_priorities_bitmap i_begin (i_end - i_begin + 1) priochar *)
+        for i = i_begin to i_end do
+          s.s_priorities_bitmap.[i] <- priochar
+        done
+      end
+    else
+      lprintf_nl "WARNING: recompute_priorities %Ld %Ld %Ld" interval_begin interval_end s.s_size
+  in
+  let rec loop = function
+  | (i_begin, priority) :: ((i_end,_) :: _ as tail) -> mark i_begin i_end priority; loop tail
+  | [i_begin, priority] -> mark i_begin s.s_size priority
+  | [] -> lprintf_nl "WARNING: recompute_priorities []"
+  in
+  loop s.s_priorities_intervals
+
+(* Intervals with fixed byte positions are needed to recompute priorities bitmap 
+  after merge, cause priobitmap depends on block size *)
+let swarmer_set_interval s (p1,p2,prio as new_interval) =
+  if !verbose then
+    lprintf_nl "swarmer_set_interval %S %Ld (%Ld,%Ld,%u)" s.s_filename s.s_size p1 p2 prio;
+  s.s_priorities_intervals <- insert_prio_interval s.s_priorities_intervals s.s_size new_interval;
+  swarmer_recompute_priorities_bitmap s
+
 (** if a swarmer is already associated with that [file_name], return it;
     Otherwise create a new one with default values, that will be fixed
     by the first frontend association *)
-
 let create_swarmer file_name file_size =
   try
     HS.find swarmers_by_name
       { dummy_swarmer with
-	s_filename = file_name
+        s_filename = file_name
       }
   with Not_found ->
     incr swarmer_counter;
@@ -604,7 +692,7 @@ let create_swarmer file_name file_size =
        blocks of this size *)
     let disk_allocation_block_size = 
       min (megabytes 10) 
-	(round_up64 (max 1L (file_size // 200L)) (megabytes 1)) in
+        (round_up64 (max 1L (file_size // 200L)) (megabytes 1)) in
     let ndiskblocks =
       1 + Int64.to_int (Int64.pred file_size // disk_allocation_block_size) in
     let rec s = {
@@ -619,6 +707,8 @@ let create_swarmer file_name file_size =
       s_strategy = AdvancedStrategy;
 
       s_verified_bitmap = VB.create nblocks VB.State_missing;
+      s_priorities_bitmap = String.make nblocks priority_zero;
+      s_priorities_intervals = [(zero, 1)]; (* JAVE init all prios to 1, thus all chunks will be downloaded as usual *)
       s_disk_allocated = Bitv.create ndiskblocks false;
       s_blocks = Array.create nblocks EmptyBlock ;
       s_block_pos = Array.create nblocks zero;
@@ -627,6 +717,7 @@ let create_swarmer file_name file_size =
 (*      s_last_seen = Array.create nblocks 0; *)
     }
     in
+    swarmer_recompute_priorities_bitmap s;
     HS.add swarmers_by_name s;
     s
 
@@ -659,7 +750,7 @@ let split_blocks s chunk_size =
         let new_blocks = (
             s.s_blocks.(index_s),
             block_begin,
-	    VB.get s.s_verified_bitmap index_s
+            VB.get s.s_verified_bitmap index_s
           ) :: new_blocks in
         iter (index_s+1) chunk_begin new_blocks
 
@@ -673,10 +764,10 @@ let split_blocks s chunk_size =
 
     else begin
       (* chunk_end < block_end
-	 We need to split this block in two parts *)
+         We need to split this block in two parts *)
         s.s_block_pos.(index_s) <- chunk_end;
         match s.s_blocks.(index_s) with
-	| EmptyBlock | CompleteBlock | VerifiedBlock ->
+        | EmptyBlock | CompleteBlock | VerifiedBlock ->
 
 (* s.s_blocks.(index_s) will appear twice in the result list *)
             let new_blocks =  (
@@ -687,7 +778,7 @@ let split_blocks s chunk_size =
             iter index_s chunk_end new_blocks
 
         | PartialBlock b1 ->
-	    (* split b1 in two; b2 is the part after [chunk_end] offset *)
+            (* split b1 in two; b2 is the part after [chunk_end] offset *)
             let b2 = {
                 block_s = s;
 
@@ -696,19 +787,19 @@ let split_blocks s chunk_size =
                 block_ranges = b1.block_ranges; (* fixed below *)
                 block_num = 0; (* fixed below *)
                 block_remaining = zero; (* fixed below *)
-		block_unselected_remaining = zero; (* fixed below *)
+                block_unselected_remaining = zero; (* fixed below *)
               } in
-	    b2.block_ranges <- cut_ranges_after b2 b1.block_ranges chunk_end;
+            b2.block_ranges <- cut_ranges_after b2 b1.block_ranges chunk_end;
             b1.block_end <- chunk_end;
 
             let new_blocks =
               (if block_is_full b1 then
 (* lprintf "Partial block b1 should become CompleteBlock\n"; *)
-		(
-		  CompleteBlock,
-		  block_begin,
-		  VB.State_complete
-		) else if block_is_empty b1 then
+                (
+                  CompleteBlock,
+                  block_begin,
+                  VB.State_complete
+                ) else if block_is_empty b1 then
 (* lprintf "Partial block b1 should become EmptyBlock\n"; *)
                   (
                     EmptyBlock,
@@ -721,17 +812,17 @@ let split_blocks s chunk_size =
                   ))
               :: new_blocks in
 
-	    if block_is_full b2 then begin
-	      (* lprintf "Partial block b2 should become CompleteBlock\n"; *)
-	      s.s_blocks.(index_s) <- CompleteBlock;
-	      VB.set s.s_verified_bitmap index_s VB.State_complete
-	    end
+            if block_is_full b2 then begin
+              (* lprintf "Partial block b2 should become CompleteBlock\n"; *)
+              s.s_blocks.(index_s) <- CompleteBlock;
+              VB.set s.s_verified_bitmap index_s VB.State_complete
+            end
             else if block_is_empty b2 then begin
-	      (* lprintf "Partial block b2 should become EmptyBlock\n"; *)
+              (* lprintf "Partial block b2 should become EmptyBlock\n"; *)
               s.s_blocks.(index_s) <- EmptyBlock;
               VB.set s.s_verified_bitmap index_s VB.State_missing;
             end 
-	    else
+            else
               s.s_blocks.(index_s) <- PartialBlock b2;
             iter index_s chunk_end new_blocks
       end
@@ -749,6 +840,7 @@ let split_blocks s chunk_size =
 
   s.s_blocks <- Array.create nblocks EmptyBlock;
   s.s_verified_bitmap <- VB.create nblocks VB.State_missing;
+  s.s_priorities_bitmap <- String.make nblocks priority_zero;
   s.s_block_pos <- Array.create nblocks zero;
   s.s_availability <- Array.create nblocks 0; (* not preserved ? *)
   s.s_nuploading <- Array.create nblocks 0; (* not preserved ? *)
@@ -760,21 +852,21 @@ let split_blocks s chunk_size =
     | (b, pos, c) :: tail ->
         begin
           match b with
-	  | PartialBlock b -> 
-	      begin
-		b.block_num <- i;
-		let block_size = compute_block_end s i --
-		  compute_block_begin s i in
-		let remaining, unselected_remaining =
-		  block_ranges_fold (fun (racc, uracc) r ->
-		    let range_size = compute_range_size r in
-		    (racc -- range_size,
-		    if r.range_nuploading = 0 then 
-		      uracc -- range_size else uracc)
-		  ) (block_size, block_size) b in
-		b.block_remaining <- remaining;
-		b.block_unselected_remaining <- unselected_remaining;
-	      end
+          | PartialBlock b -> 
+              begin
+                b.block_num <- i;
+                let block_size = compute_block_end s i --
+                  compute_block_begin s i in
+                let remaining, unselected_remaining =
+                  block_ranges_fold (fun (racc, uracc) r ->
+                    let range_size = compute_range_size r in
+                    (racc -- range_size,
+                    if r.range_nuploading = 0 then 
+                      uracc -- range_size else uracc)
+                  ) (block_size, block_size) b in
+                b.block_remaining <- remaining;
+                b.block_unselected_remaining <- unselected_remaining;
+              end
           | EmptyBlock | CompleteBlock | VerifiedBlock -> ()
         end;
         s.s_blocks.(i) <- b;
@@ -783,7 +875,9 @@ let split_blocks s chunk_size =
 
         iter (i+1) tail
   in
-  iter 0 blocks
+  iter 0 blocks;
+  swarmer_recompute_priorities_bitmap s
+
 
 (** Associate a(n additional) frontend to a swarmer *)
 
@@ -814,12 +908,12 @@ let associate is_primary t s =
   end else begin
     match s.s_networks with
     | tprim :: _ ->
-	assert(tprim.t_primary);
-	if file_disk_name t.t_file <> file_disk_name tprim.t_file then
-	  (* TODO: transfer data into swarmer instead of discarding it *)
-	  Unix32.remove (file_fd t.t_file);
-	t.t_primary <- false;
-	s.s_networks <- s.s_networks @ [t];
+        assert(tprim.t_primary);
+        if file_disk_name t.t_file <> file_disk_name tprim.t_file then
+          (* TODO: transfer data into swarmer instead of discarding it *)
+          Unix32.remove (file_fd t.t_file);
+        t.t_primary <- false;
+        s.s_networks <- s.s_networks @ [t];
     | [] -> assert false
   end;
 
@@ -926,7 +1020,7 @@ let is_fully_preallocated t interval_begin interval_end =
   try
     iter_disk_space (fun s fd disk_block ->
       if not(Bitv.get s.s_disk_allocated disk_block) then
-	raise Not_preallocated_block_found
+        raise Not_preallocated_block_found
     ) t interval_begin interval_end;
     true
   with Not_preallocated_block_found -> false
@@ -960,7 +1054,7 @@ let check_finished t =
       false
   | FileDownloading ->
       if VB.existsi (fun i c -> c <> VB.State_verified)
-	t.t_converted_verified_bitmap then false
+        t.t_converted_verified_bitmap then false
       else begin
         if file_size file <> file_downloaded t.t_file then
           lprintf_nl "Downloaded size differs after complete verification";
@@ -985,13 +1079,13 @@ let print_s str s =
       let block_end = compute_block_end s i in
       lprintf "%Ld - %Ld [%Ld] %c " block_begin block_end
         (block_end -- block_begin) 
-	(VB.state_to_char 
-	  (VB.get s.s_verified_bitmap i));
+        (VB.state_to_char 
+          (VB.get s.s_verified_bitmap i));
       List.iter (fun t ->
           let j = t.t_chunk_of_block.(i) in
           lprintf "(b %d %c [" j 
-	    (VB.state_to_char 
-	      (VB.get t.t_converted_verified_bitmap j));
+            (VB.state_to_char 
+              (VB.get t.t_converted_verified_bitmap j));
           List.iter (fun ii -> lprintf "%d " ii) t.t_blocks_of_chunk.(j);
           lprintf "]";
       ) s.s_networks;
@@ -1050,7 +1144,7 @@ let add_file_downloaded maybe_t s size =
       (match maybe_t with
        | None -> ()
        | Some tt ->
-	   if t.t_num <> tt.t_num then
+           if t.t_num <> tt.t_num then
              add_file_downloaded tt.t_file size);
       if file_downloaded t.t_file < zero then
         lprintf_nl "ERROR: file_downloaded < zero!";
@@ -1105,16 +1199,16 @@ let set_swarmer_state_missing s i =
       (VB.set s.s_verified_bitmap i VB.State_missing;
        List.iter (fun t ->
           let j = t.t_chunk_of_block.(i) in
-	  match VB.get t.t_converted_verified_bitmap j with
-	  | VB.State_missing -> ()
-	  | VB.State_partial ->
-	      if List.for_all (fun i -> VB.get s.s_verified_bitmap i = VB.State_missing)
-		t.t_blocks_of_chunk.(j) then
-		  VB.set t.t_converted_verified_bitmap j VB.State_missing
-	  | VB.State_complete -> 
-	      lprintf_nl "set_swarmer_state_missing: invalidating a block within a completed chunk?"
-	  | VB.State_verified -> 
-	      lprintf_nl "set_swarmer_state_missing: invalidating a block within a verified chunk?"
+          match VB.get t.t_converted_verified_bitmap j with
+          | VB.State_missing -> ()
+          | VB.State_partial ->
+              if List.for_all (fun i -> VB.get s.s_verified_bitmap i = VB.State_missing)
+                t.t_blocks_of_chunk.(j) then
+                  VB.set t.t_converted_verified_bitmap j VB.State_missing
+          | VB.State_complete -> 
+              lprintf_nl "set_swarmer_state_missing: invalidating a block within a completed chunk?"
+          | VB.State_verified -> 
+              lprintf_nl "set_swarmer_state_missing: invalidating a block within a verified chunk?"
       ) s.s_networks)
   | VB.State_missing -> ()
   | VB.State_partial ->
@@ -1129,20 +1223,20 @@ let set_swarmer_state_partial s i =
       List.iter (fun t ->
         let j = t.t_chunk_of_block.(i) in
         match VB.get t.t_converted_verified_bitmap j with
-	| VB.State_missing -> 
-	    VB.set t.t_converted_verified_bitmap j VB.State_partial
-	| VB.State_partial -> ()
-	| VB.State_complete -> 
-	    lprintf_nl "set_swarmer_state_partial: partial block within a completed chunk?"
-	| VB.State_verified -> 
-	    lprintf_nl "set_swarmer_state_partial: partial block within a verified chunk?"
+        | VB.State_missing -> 
+            VB.set t.t_converted_verified_bitmap j VB.State_partial
+        | VB.State_partial -> ()
+        | VB.State_complete -> 
+            lprintf_nl "set_swarmer_state_partial: partial block within a completed chunk?"
+        | VB.State_verified -> 
+            lprintf_nl "set_swarmer_state_partial: partial block within a verified chunk?"
       ) s.s_networks
   | VB.State_partial -> ()
   | VB.State_complete -> 
       lprintf_nl "set_swarmer_state_partial: trying to demote a completed block?"
   | VB.State_verified -> 
       lprintf_nl "set_swarmer_state_partial: trying to demote a verified block?"
-	
+        
 
 (* we finished this block, trying to escalate to primary frontend
    verification bitmap *)
@@ -1152,19 +1246,19 @@ let set_swarmer_state_complete s i =
       (VB.set s.s_verified_bitmap i VB.State_complete;
       match s.s_networks with
       | t :: _ ->
-	  assert (t.t_primary);
+          assert (t.t_primary);
           let j = t.t_chunk_of_block.(i) in
-	  (match VB.get t.t_converted_verified_bitmap j with
-	  | VB.State_missing | VB.State_partial -> 
-	      if List.for_all (fun i -> VB.get s.s_verified_bitmap i = VB.State_complete)
-		t.t_blocks_of_chunk.(j) then begin
-		  t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1;
-		  VB.set t.t_converted_verified_bitmap j VB.State_complete
-		end
-	  | VB.State_complete -> ()
-	  | VB.State_verified -> 
-	      (* lprintf_nl "set_swarmer_state_complete: trying to demote a verified block? (1)" *)
-	      ())
+          (match VB.get t.t_converted_verified_bitmap j with
+          | VB.State_missing | VB.State_partial -> 
+              if List.for_all (fun i -> VB.get s.s_verified_bitmap i = VB.State_complete)
+                t.t_blocks_of_chunk.(j) then begin
+                  t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1;
+                  VB.set t.t_converted_verified_bitmap j VB.State_complete
+                end
+          | VB.State_complete -> ()
+          | VB.State_verified -> 
+              (* lprintf_nl "set_swarmer_state_complete: trying to demote a verified block? (1)" *)
+              ())
       | [] -> assert false)
   | VB.State_complete -> ()
   | VB.State_verified -> 
@@ -1172,15 +1266,15 @@ let set_swarmer_state_complete s i =
       VB.set s.s_verified_bitmap i VB.State_complete;
       match s.s_networks with
       | t :: _ ->
-	  assert (t.t_primary);
+          assert (t.t_primary);
           let j = t.t_chunk_of_block.(i) in
-	  (match VB.get t.t_converted_verified_bitmap j with
-	   | VB.State_verified ->
-	       VB.set t.t_converted_verified_bitmap j VB.State_complete;
-	       t.t_nverified_chunks <- t.t_nverified_chunks - 1;
-	   | VB.State_complete -> ()
-	   | VB.State_missing | VB.State_partial ->
-	       lprintf_nl "BUG: set_swarmer_state_complete: demoting a verified block from an incomplete chunk")
+          (match VB.get t.t_converted_verified_bitmap j with
+           | VB.State_verified ->
+               VB.set t.t_converted_verified_bitmap j VB.State_complete;
+               t.t_nverified_chunks <- t.t_nverified_chunks - 1;
+           | VB.State_complete -> ()
+           | VB.State_missing | VB.State_partial ->
+               lprintf_nl "BUG: set_swarmer_state_complete: demoting a verified block from an incomplete chunk")
       | [] -> assert false
 
 
@@ -1194,49 +1288,49 @@ let set_swarmer_state_verified s i =
       match s.s_networks with
       | [] -> assert false
       | tprim :: secondaries ->
-	  assert (tprim.t_primary);
-	  (* that test is somewhat redundant, since only primary
-	     frontends with verification can have merged secondary
-	     frontends; See merge *)
-	  match tprim.t_verifier with
-	  | NoVerification | VerificationNotAvailable -> ()
-	  | Verification _ | ForceVerification ->
-	      let jprim = tprim.t_chunk_of_block.(i) in
-	      assert (VB.get tprim.t_converted_verified_bitmap jprim = VB.State_verified);
-	      List.iter (fun t ->
-		assert (not t.t_primary);
-		let j = t.t_chunk_of_block.(i) in
-		if List.for_all (fun i -> VB.get s.s_verified_bitmap i = VB.State_verified)
+          assert (tprim.t_primary);
+          (* that test is somewhat redundant, since only primary
+             frontends with verification can have merged secondary
+             frontends; See merge *)
+          match tprim.t_verifier with
+          | NoVerification | VerificationNotAvailable -> ()
+          | Verification _ | ForceVerification ->
+              let jprim = tprim.t_chunk_of_block.(i) in
+              assert (VB.get tprim.t_converted_verified_bitmap jprim = VB.State_verified);
+              List.iter (fun t ->
+                assert (not t.t_primary);
+                let j = t.t_chunk_of_block.(i) in
+                if List.for_all (fun i -> VB.get s.s_verified_bitmap i = VB.State_verified)
                   t.t_blocks_of_chunk.(j) then
-		    match t.t_verifier with
-		    | NoVerification | VerificationNotAvailable ->
-			(* we have no way to check data integrity
-			   for this network, assume other(s) know
-			   better *)
-			(match VB.get t.t_converted_verified_bitmap j with
-			 | VB.State_missing | VB.State_partial ->
-			     VB.set t.t_converted_verified_bitmap j VB.State_verified;
-			     t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1;
-			     t.t_nverified_chunks <- t.t_nverified_chunks + 1
-			 | VB.State_complete ->
-			     VB.set t.t_converted_verified_bitmap j VB.State_verified;
-			     t.t_nverified_chunks <- t.t_nverified_chunks + 1
-			 | VB.State_verified -> ())
-		    | ForceVerification
-		    | Verification _ ->
-			(* all chunks are verified, so set
-			   converted_verified_bitmap to State_complete,
-			   probably to trigger data verification later.
-			   
-			   Is that code necessary at all ? *)
-			(match VB.get t.t_converted_verified_bitmap j with
-			 | VB.State_missing | VB.State_partial ->
-			     VB.set t.t_converted_verified_bitmap j VB.State_complete;
-			     t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1
-			 | VB.State_complete -> ()
-			 | VB.State_verified -> 
-			     lprintf_nl "set_swarmer_state_verified: trying to demote a verified block in another frontend?")
-	      ) secondaries)
+                    match t.t_verifier with
+                    | NoVerification | VerificationNotAvailable ->
+                        (* we have no way to check data integrity
+                           for this network, assume other(s) know
+                           better *)
+                        (match VB.get t.t_converted_verified_bitmap j with
+                         | VB.State_missing | VB.State_partial ->
+                             VB.set t.t_converted_verified_bitmap j VB.State_verified;
+                             t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1;
+                             t.t_nverified_chunks <- t.t_nverified_chunks + 1
+                         | VB.State_complete ->
+                             VB.set t.t_converted_verified_bitmap j VB.State_verified;
+                             t.t_nverified_chunks <- t.t_nverified_chunks + 1
+                         | VB.State_verified -> ())
+                    | ForceVerification
+                    | Verification _ ->
+                        (* all chunks are verified, so set
+                           converted_verified_bitmap to State_complete,
+                           probably to trigger data verification later.
+                           
+                           Is that code necessary at all ? *)
+                        (match VB.get t.t_converted_verified_bitmap j with
+                         | VB.State_missing | VB.State_partial ->
+                             VB.set t.t_converted_verified_bitmap j VB.State_complete;
+                             t.t_ncomplete_chunks <- t.t_ncomplete_chunks + 1
+                         | VB.State_complete -> ()
+                         | VB.State_verified -> 
+                             lprintf_nl "set_swarmer_state_verified: trying to demote a verified block in another frontend?")
+              ) secondaries)
   | VB.State_verified -> ()
 
 (** set block as completed, closing all remaining ranges, and
@@ -1281,7 +1375,7 @@ let set_verified_block s j =
 
 (* We've seen how swarmer verification propagates to the frontend(s)
    verifications, now let's see the reverse *)
-	
+        
 let set_frontend_state_missing t j =
   assert(VB.get t.t_converted_verified_bitmap j = VB.State_complete);
   let s = t.t_s in
@@ -1295,17 +1389,17 @@ let set_frontend_state_missing t j =
       VB.set t.t_converted_verified_bitmap j VB.State_missing;
       List.iter (fun i ->
         match s.s_blocks.(i) with
-	| EmptyBlock -> set_swarmer_state_missing s i
+        | EmptyBlock -> set_swarmer_state_missing s i
         | PartialBlock _ ->  set_swarmer_state_partial s i
         | CompleteBlock ->
             let block_begin = compute_block_begin s i in
             let block_end = compute_block_end s i in
-	    (* negative *)
+            (* negative *)
             add_file_downloaded None s (block_begin -- block_end);
-	      
+              
             s.s_blocks.(i) <- EmptyBlock;
             set_swarmer_state_missing s i
-	      
+              
         | VerifiedBlock -> assert false
       ) t.t_blocks_of_chunk.(j)
     end
@@ -1328,11 +1422,11 @@ let set_frontend_state_complete t j =
   match VB.get t.t_converted_verified_bitmap j with
   | VB.State_missing | VB.State_partial ->
       if (not !CommonGlobals.is_startup_phase) && (!verbose_swarming || !verbose) then
-	lprintf_nl "Completed block %d/%d of %s"
+        lprintf_nl "Completed block %d/%d of %s"
           (j + 1) t.t_nchunks (file_best_name t.t_file);
       let s = t.t_s in
       List.iter (fun i -> set_completed_block None s i)
-	t.t_blocks_of_chunk.(j)
+        t.t_blocks_of_chunk.(j)
   | VB.State_complete | VB.State_verified -> ()
 
 (* aka set_verified_chunk (internal) *)
